#ifndef __BOARD_H__
#define __BOARD_H__

#include "pattern.h"
#include "define.h"

///***			\				***///

//  
struct move_data {
	int color;
	int pos;
};

//  
struct stone_data {
	int color;
	int string_number;
	int next_stone;
};

// A 
struct string_data {
	int color;
	int size;
	int origin;
	int liberties;
	int mark;
};

// ΋ǂ̑S 
struct game {
	int prisoner[S_MAX]; // AQn}

	int moves;				
	struct move_data record[MAX_RECORDS];

	struct move_data ko; // 
	int ko_move;

	struct stone_data board[BOARD_MAX];

	struct string_data string[MAX_STRINGS];
	int next_string;
	int liberty;
	int liberty_mark;
	int string_mark;
	int mark[BOARD_MAX];

	int pat3[BOARD_MAX];

	int candidates[BOARD_MAX]; // 
	int sum_candidates_column[BOARD_SIZE];
	int sum_candidates;
};

///***			ϐ錾			***///

// XW 
extern int board_x[BOARD_MAX];

// YW 
extern int board_y[BOARD_MAX];

// 4ߖT̐ 
extern int nb4_empty[PATTERN3_MAX];
extern int nb4_black[PATTERN3_MAX];
extern int nb4_white[PATTERN3_MAX];

//  
extern int eye[PATTERN3_MAX];

///***			֐錾			***///

//  
struct game *InitializeGame( void );
struct game *SetUpGame( void );

// ݒ 
void ClearGame( struct game *game );

// Rs[ 
void CopyGame( struct game *g2, struct game *g1 );

//  
void DoneGame( struct game *game );

// 萔̐ݒ 
void BoardConst( void );

// ߖT̐̏ 
void InitializeNeighbor( void );

// ̏ 
void InitializeEye( void );

// Ղ\ 
void DisplayBoard( struct game *game  );

// @̔
int SimpleCheckLegal( struct game *game, int color, int pos );
int CheckLegal( struct game *game, int color, int pos );

// ̔ 
int CheckEye( struct game *game, int color, int pos );

// @肩łȂ 
int CheckLegalAndEye( struct game *game, int color, int pos );

// E̔ 
int CheckSuicide( struct game *game, int color, int pos );

// Ղɐ΂u
void SetStone( struct game *game, int color, int pos );

// ͂܂ꂽ΂菜 
int	RemoveStone( struct game *game, int str );

// A̐VK쐬 
void CreateNewString( struct game *game, int pos );

// ̘͂Aɐ΂ǉ 
void ExtendNeighborString( struct game *game, int str, int pos );

// A̍쐬 +  
void AssimilateNeighborString( struct game *game, int pos );

// A̓ 
void AssimilateString( struct game *game, int str, int pos );

// A̕\ 
void DisplayString( struct game *game );

// _̍XV 
void UpdateLiberties( struct game *game, int str );

// s̔ 
int BoardScore( struct game *game );


#endif