#ifndef __DEFINE_H__
#define __DEFINE_H__

//////////////////////////////
///***		BOARD_H		***///
//////////////////////////////

enum STONE {
	S_EMPTY,	// _
	S_BLACK,	// @
	S_WHITE,	// 
	S_OB,		// ՊO
	S_MAX,
};

#define TRUE  1
#define FALSE 0

#define OTHER_COLOR( color ) ((color)^0x3)	// F] 

#define PASS   0
#define RESIGN -1

#define KOMI 6.5	// R~

#define PURE_BOARD_SIZE	9	// Ղ̖{̑傫
#define OB_SIZE 1			// ՊȎ傫
#define BOARD_SIZE	(PURE_BOARD_SIZE + (OB_SIZE + OB_SIZE))	// Ղ̑傫 

#define BOARD_START OB_SIZE
#define BOARD_END	(OB_SIZE+PURE_BOARD_SIZE-1)

#define PURE_BOARD_MAX	(PURE_BOARD_SIZE * PURE_BOARD_SIZE)
#define BOARD_MAX		(BOARD_SIZE * BOARD_SIZE)

#define MAX_STRINGS (PURE_BOARD_SIZE * PURE_BOARD_SIZE * 4/5)	// A̍ő吔 

#define BOARD_FIRST	POS(BOARD_START, BOARD_START)
#define BOARD_LAST	POS(BOARD_END, BOARD_END)

#define MAX_LIBERTIES 2

#define MAX_RECORDS 1000
#define MAX_MOVES MAX_RECORDS-1	// ő萔 

#define POS(x, y)     ((x) + (y) * BOARD_SIZE)
#define X(pos)        ((pos) % BOARD_SIZE)
#define Y(pos)        ((pos) / BOARD_SIZE)
#define NORTH(pos)    ((pos) - BOARD_SIZE)
#define EAST(pos)     ((pos) + 1)
#define SOUTH(pos)    ((pos) + BOARD_SIZE)
#define WEST(pos)     ((pos) - 1)

// ߖT̍W 
#define NE  (-BOARD_SIZE+1)
#define NW  (-BOARD_SIZE-1)
#define SE  (BOARD_SIZE+1)
#define SW  (BOARD_SIZE-1)

//////////////////////////////
///***		GTP_H		***///
//////////////////////////////

#define COMMANDNUM 19			// R}ȟ
#define INPUTBUF 256
#define DELIM    " "			// R}hɎgp
#define PROGRAMNAME "moskit"		// ̃vO
#define PROGRAMVERSION "1.0.0"	// ̃vOo[Wio[
#define PROTOCOLVERSION "1"		// ̃vgRo[Wio[
#define REMOVE_NEWLINE(command) if(command[strlen(command)-1] == '\n') command[strlen(command)-1] = '\0'

//////////////////////////////////
///***		GTPCONV_H		***///
//////////////////////////////////

#define PATTERN3_MAX 65536	// 3~3pattern

//////////////////////////////////
///***		UCB_H		***///
//////////////////////////////////

#define LIMIT_TIME	0.90
#define RESIGN_RATE	0.30

#endif