#include <stdio.h>
#include <string.h>

#include "pattern.h"
#include "board.h"

// rbg񑀍
#define REV3(p) ((p >> 4) | (p & 0xc) | ((p & 0x3) << 4))
#define REV2(p) ((p >> 2) | ((p & 0x3) << 2))

// ߖT̍W
#define N	(-BOARD_SIZE)
#define S	BOARD_SIZE
#define E	1
#define W	-1

// ݒ
void ClearPattern3( int *pat3 )
{
	int y;

	memset(pat3, 0, sizeof(int)*BOARD_MAX);

	for( y=BOARD_START; y<=BOARD_END; y++ ){
		pat3[POS(y,BOARD_START)] |= 0x003F;	// 
		pat3[POS(BOARD_END,y)]	 |= 0xC330;	// E
		pat3[POS(y,BOARD_END)]	 |= 0xFC00;	// 
		pat3[POS(BOARD_START,y)] |= 0x0CC3;	// 
	}
}

///***				XV				***///
void UpdatePattern3Empty( int *pat3, int pos )
{
	pat3[pos + NW] &= 0x3FFF;
	pat3[pos + N ] &= 0xCFFF;
	pat3[pos + NE] &= 0xF3FF;
	pat3[pos + W ] &= 0xFCFF;
	pat3[pos + E ] &= 0xFF3F;
	pat3[pos + SW] &= 0xFFCF;
	pat3[pos + S ] &= 0xFFF3;
	pat3[pos + SE] &= 0xFFFC;
}

void UpdatePattern3Black( int *pat3, int pos )
{
	pat3[pos + NW] |= 0x4000;
	pat3[pos + N ] |= 0x1000;
	pat3[pos + NE] |= 0x0400;
	pat3[pos + W ] |= 0x0100;
	pat3[pos + E ] |= 0x0040;
	pat3[pos + SW] |= 0x0010;
	pat3[pos + S ] |= 0x0004;
	pat3[pos + SE] |= 0x0001;
}

void UpdatePattern3White( int *pat3, int pos )
{
	pat3[pos + NW] |= 0x8000;
	pat3[pos + N ] |= 0x2000;
	pat3[pos + NE] |= 0x0800;
	pat3[pos + W ] |= 0x0200;
	pat3[pos + E ] |= 0x0080;
	pat3[pos + SW] |= 0x0020;
	pat3[pos + S ] |= 0x0008;
	pat3[pos + SE] |= 0x0002;
}


///***			p^[Ԃ			***///
void Pattern3Transpose8( int pat3, int *transp )
{
	transp[0] = pat3;
	transp[1] = Pattern3VerticalMirror(pat3);
	transp[2] = Pattern3HorizontalMirror(pat3);
	transp[3] = Pattern3VerticalMirror(transp[2]);
	transp[4] = Pattern3Rotate90(pat3);
	transp[5] = Pattern3Rotate90(transp[1]);
	transp[6] = Pattern3Rotate90(transp[2]);
	transp[7] = Pattern3Rotate90(transp[3]);
}

void Pattern3Transpose16( int pat3, int *transp )
{
	transp[0] = pat3;
	transp[1] = Pattern3VerticalMirror(pat3);
	transp[2] = Pattern3HorizontalMirror(pat3);
	transp[3] = Pattern3VerticalMirror(transp[2]);
	transp[4] = Pattern3Rotate90(pat3);
	transp[5] = Pattern3Rotate90(transp[1]);
	transp[6] = Pattern3Rotate90(transp[2]);
	transp[7] = Pattern3Rotate90(transp[3]);
	transp[8] = Pattern3Reverse(transp[0]);
	transp[9] = Pattern3Reverse(transp[1]);
	transp[10] = Pattern3Reverse(transp[2]);
	transp[11] = Pattern3Reverse(transp[3]);
	transp[12] = Pattern3Reverse(transp[4]);
	transp[13] = Pattern3Reverse(transp[5]);
	transp[14] = Pattern3Reverse(transp[6]);
	transp[15] = Pattern3Reverse(transp[7]);
}


// F̔]
int Pattern3Reverse( int pat3 )
{
	return ((pat3 >> 1) & 0x5555) | ((pat3 & 0x5555) << 1);
}

// ㉺Ώ
int Pattern3VerticalMirror( int pat3 )
{
	return ((pat3 & 0xfc00) >> 10) | (pat3 & 0x03c0) | ((pat3 & 0x003f) << 10);
}

// EΏ
int Pattern3HorizontalMirror( int pat3 )
{
	return (REV3((pat3 & 0xfc00) >> 10) << 10)
		| (REV2((pat3 & 0x03c0) >> 6) << 6)
		| REV3((pat3 & 0x003f));
}

// 90x]
int Pattern3Rotate90(int pat3)
{
	/* 0 1 2    2 4 7
	 * 3   4 -> 1   6
	 * 5 6 7    0 3 5 */

	return ((pat3 & 0x0003) << 10)
		 | ((pat3 & 0x0c0c) << 4)
		 | ((pat3 & 0x3030) >> 4)
		 | ((pat3 & 0x00c0) << 6)
		 | ((pat3 & 0x0300) >> 6)
		 | ((pat3 & 0xc000) >> 10);
}