#include <stdio.h>

#include "playout.h"
#include "random.h"

int PlayOut( struct game *game, int starting_color )
{
	int color = starting_color;
	int pos = -1;
	double score = 0;
	int result = 0;
	int length;
	int passes;

	length = MAX_MOVES - game->moves;
	if(length < 0) length = 0;

	passes = ( game->record[game->moves - 1].pos == PASS && game->moves > 1 );

	while (length-- > 0 && passes < 2) {
		pos = RandomMove( game, color );
		SetStone( game, color, pos );

		if (pos == PASS) passes++;
		else passes = 0;

		color = OTHER_COLOR(color);
	}

	score = (double)BoardScore( game ) - KOMI + (starting_color == S_BLACK ? -1 : 1);

	// 
	if (score > 0) result = (starting_color == S_BLACK ? 1 : 0);
	// 
	else if(score < 0) result = (starting_color == S_WHITE ? 1 : 0); 

	return result;
}