#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <memory.h>
#include <time.h>
#include <float.h>

#include "ucb.h"
#include "board.h"
#include "playout.h"
#include "lower.h"

//UCBlpĒ(؍\Ȃ)
int UCBMove( struct game *game, int color )
{
	struct game *po_game = SetUpGame();
	struct pData pd[BOARD_MAX];
	int i, x, y, pos, max_pos, max_count, win_count = 0;
	int playout_count = 100000; // 肫ȂƂĐݒ
	float ucb_value, max_ucb, win_per, winning_rate;
	clock_t begin_time;
	double finish_time;

	begin_time = clock();
	memset(pd, 0, sizeof( pd ));

	if( game->moves == 1 ) return 0x003c; // V(߂I)
	else if( game->record[game->moves - 1].pos == PASS ) return PASS; //肪pXȂpXI

	for(i = 0; i < playout_count ; ++i){
		max_ucb = 0;
		max_pos = 0;

		for(y = BOARD_START; y <= BOARD_END; ++y){
			for(x = BOARD_START; x <= BOARD_END; ++x){
				pos = POS(x, y);

				if( !game->candidates[pos] || !CheckLegalAndEye( game, color, pos ) ) continue;
				
				// UCBl
				if( !pd[pos].move_count ) ucb_value = FLT_MAX;
				// UCBlvZ
				else{
					win_per = (float)pd[pos].win_num/pd[pos].move_count; 
					ucb_value = (float)( win_per + 0.4*sqrt( log( (double) i )/pd[pos].move_count) );
				}
			
				// UCBőlXV
				if(ucb_value > max_ucb){
					max_ucb = ucb_value;
					max_pos = pos;
				}

			}
		}

		CopyGame(po_game, game);
		SetStone(po_game, color, max_pos);
		pd[max_pos].win_num += 1 - PlayOut( po_game, OTHER_COLOR(color) );
		win_count += 1 - PlayOut( po_game, OTHER_COLOR(color) );
		pd[max_pos].move_count++;

		// Ԑ
		finish_time = GetSpendTime(begin_time);
		if( finish_time >= LIMIT_TIME ){
			playout_count = i;
			break;
		}
	}

	DoneGame(po_game);

	max_count = pd[0].move_count;

	for(i = 1; i < BOARD_MAX; ++i){
		if( pd[i].move_count > max_count ){ 
			max_count = pd[i].move_count;
			max_pos = i;
		}
	}
	// pX
	if( !max_pos ){
		max_pos = PASS;
	}
	//RISIGNpvZ
	else {
		winning_rate = (float)win_count/playout_count;
			//pd[max_pos].win_num/pd[max_pos].move_count;
		fprintf(stderr, "rate:%f\n", winning_rate);
		if ( winning_rate <= RESIGN_RATE ){
			max_pos = RESIGN;
		}
	}

	//finish_time = GetSpendTime(begin_time);

	fprintf(stderr, "%5f sec, (%d games/sec)\n", finish_time, (int)( playout_count/finish_time ));
	fflush(stderr);

	return max_pos;
}